//****************************************************************************
//	aisa47w.pas
//
//	aISA-R47
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/05/26
//
//****************************************************************************

unit aisa47w;

interface

uses
	Windows;

{ Errors }

const
	AISA47_SUCCESS							= 0;	 { ُȂ }
	AISA47_ERR_SYSTEM						= 1;	 { GetLastError sĂ }
	AISA47_ERR_NO_DEVICE				= 2;	 { gXbgȂ}
	AISA47_ERR_IN_USE						= 3;	 { w肳ꂽXbg͎gp }
	AISA47_ERR_INVALID_SLOT			= 4;	 { sȃXbgԍw肵 }
	AISA47_ERR_RESOURCE					= 5;	 { \[XG[ }
	AISA47_ERR_INVALID_PORT			= 6;	 { sȃ|[gv }
	AISA47_ERR_INVALID_ARGUMENT = 7;	 { sȈv }

{ Port numbers }

const
	AISA47_PORT_0	= 0;
	AISA47_PORT_1	= 1;


{ Miscellaneous }

const
	AISA47_MAX_SLOTS	= 16;	{ Maximum number of slots }

const
	AISA47_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	AISA47_DLL_NAME = 'aisa47.dll';		{ DLL }

function Aisa47wDllOpen: Boolean;			{ DLL [h }
function Aisa47wDllClose: Boolean;		{ DLL A[h }


const
	AISA47_SLOT_AUTO = $ffff;

{ aISA-R47 DLL,Driver̃o[Wԍ擾 }
function Aisa47wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;


{ CӂaISA-R47̎gp錾 }
function Aisa47wCreate(var pwLogSlot: Word): Boolean;
{ CӂaISA-R47̎gpJ }
function Aisa47wClose(wLogSlot: Word): Boolean;


{ Resource infomation structure }

const
		AISA47_MAX_MEM	=	 9;
		AISA47_MAX_IO		= 20;
		AISA47_MAX_IRQ	=	 7;
		AISA47_MAX_DMA	=	 7;

type
		TAISA47RESOURCE = record
				dwNumMemWindows:DWORD;																	{ EBhE gp }
				dwMemBase:			array [1 .. AISA47_MAX_MEM] of DWORD;		{ EChEx[XAhX@gp }
				dwMemLength:		array [1 .. AISA47_MAX_MEM] of DWORD;		{ EChE@gp }
				dwMemAttrib:		array [1 .. AISA47_MAX_MEM] of DWORD;		{ EChE@gp }
				dwNumIOPorts:		DWORD;																	{ I/O|[g }
				dwIOPortBase:		array [1 .. AISA47_MAX_IO] of DWORD;		{ I/O|[gx[XAhX }
				dwIOPortLength: array [1 .. AISA47_MAX_IO] of DWORD;		{ I/O|[g }
				dwNumIRQs:			DWORD;																	{ IRQ@gp }
				dwIRQRegisters: array [1 .. AISA47_MAX_IRQ] of DWORD;		{ IRQXg gp }
				dwIRQAttrib:		array [1 .. AISA47_MAX_IRQ] of DWORD;		{ IRQXg gp }
				dwNumDMAs:			DWORD;																	{ DMA`l gp }
				dwDMALst:				array [1 .. AISA47_MAX_DMA] of DWORD;		{ DMA`lXg gp }
				dwDMAAttrib:		array [1 .. AISA47_MAX_DMA] of DWORD;		{ DMA`lXg gp }
				dwReserved1:		array [1 .. 3] of DWORD;								{ \  }
		end;

PAISA47RESOURCE = ^TAISA47RESOURCE;

{ \[X擾 }
function Aisa47wGetResource(wLogSlot: Word;  pResInfo: PAISA47RESOURCE): Boolean;

{ Cӂ̃|[gf[^ }
function Aisa47wInPort(wLogSlot: Word; dwPort: DWord; var pbInValue: Byte): Boolean;
{ Cӂ̃|[gփf[^o }
function Aisa47wOutPort(wLogSlot: Word; dwPort: DWord; bOutValue: Byte): Boolean;


{ aISA-R47̃G[R[h }
function Aisa47wGetLastError(wLogSlot: Word): DWord;

implementation

type
	TAisa47GetVersion = function(var pdwDllVer: DWORD; var pdwDrvVer: DWORD): BOOL; stdcall;
	TAisa47Create = function(var pwLogSlot: Word): BOOL; stdcall;
	TAisa47Close = function(wLogSlot:	WORD): BOOL; stdcall;
	TAisa47GetResource = function(wLogSlot: WORD; res: PAISA47RESOURCE):	BOOL; stdcall;
	TAisa47InPort = function(wLogSlot: WORD; dwLogPort: DWORD; var lpbInValue: BYTE): BOOL; stdcall;
	TAisa47OutPort = function(wLogSlot: WORD; dwLogPort: DWORD; bOutValue: BYTE): BOOL; stdcall;
	TAisa47GetLastError = function(wLogSlot: WORD): DWORD; stdcall;

function Aisa47wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

 { DLL GNX|[g֐AhX̊i[ϐ }
var
	pAisa47GetVersion: TAisa47GetVersion;
	pAisa47Create: TAisa47Create;
	pAisa47Close: TAisa47Close;
	pAisa47GetResource: TAisa47GetResource;
	pAisa47InPort: TAisa47InPort;
	pAisa47OutPort: TAisa47OutPort;
	pAisa47GetLastError: TAisa47GetLastError;


//****************************************************************************
// @\			aisa47.dll[h
// 			Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa47wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(AISA47_DLL_NAME);
	if hDLL = 0 then Exit;

	if Aisa47wGetDllExportFunc = False then
  begin
       Aisa47wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		   Exit;
  end;

	Result := True;
end;

//****************************************************************************
// @\			aisa47.dllA[h
// 			Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa47wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;

//****************************************************************************
// @\			aISA-R47 DLL,Driver̃o[Wԍ擾
// 			pdwDllVer --- DLLo[Wԍi[
//					pdwDrvVer --- Drivero[Wԍi[
// ߂l 	True  				--- 
//		  		False 				--- s
//****************************************************************************
function Aisa47wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa47GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// @\			aISA-R47̔Cӂ̃foCX̎gp錾
// 			pwLogSlot	 --- gpfoCXi[AhX
// ߂l 	True  		 --- 
//		  		False 		 --- s
//****************************************************************************
function Aisa47wCreate(var pwLogSlot: Word): Boolean;
begin
  Result := False;

  if hDLL = 0 then Exit;

	Result := pAisa47Create(pwLogSlot);
end;

//****************************************************************************
// @\			aISA-R47̔Cӂ̃foCX̎gpJ
// 			wLogSlot --- gpfoCX
// ߂l 	True  	 --- 
//		  		False 	 --- s
//****************************************************************************
function Aisa47wClose(wLogSlot: Word): Boolean;
begin
  Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa47Close(wLogSlot);
end;


//****************************************************************************
// @\		wfoCX̃\[X擾
// 			wLogSlot --- ׂfoCX
//					pResInfo --- \[Xi[\̂̃AhX
// ߂l 	True  	 --- 
//		  		False 	 --- s
//****************************************************************************
function Aisa47wGetResource(wLogSlot: Word;  pResInfo: PAISA47RESOURCE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa47GetResource(wLogSlot, pResInfo);
end;


//****************************************************************************
// @\			Cӂ̃|[gf[^
// 			wLogSlot	--- ͂foCX
//					dwPort		--- ͂|[g
//					pbInValue --- ̓f[^i[
// ߂l 	True  		--- 
//		  		False 		--- s
//****************************************************************************
function Aisa47wInPort(wLogSlot: Word; dwPort: DWord; var pbInValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa47InPort(wLogSlot, dwPort, pbInValue);
end;

//****************************************************************************
// @\			Cӂ̃|[gփf[^o
// 			wLogSlot	--- o͂foCX
//					dwPort		--- o͂|[g
//					bOutValue --- o͂f[^
// ߂l 	True  		--- 
//		  		False 		--- s
//****************************************************************************
function Aisa47wOutPort(wLogSlot: Word; dwPort: DWord; bOutValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa47OutPort(wLogSlot, dwPort, bOutValue);
end;

//****************************************************************************
// @\			aISA-R47̃G[R[h
// 			wLogSlot --- G[foCX
// ߂l 				 	 --- G[R[h
//****************************************************************************
function Aisa47wGetLastError(wLogSlot: Word): DWord;
begin
	Result := AISA47_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pAisa47GetLastError(wLogSlot);
end;

//****************************************************************************
// 	  	DLLGNX|[g֐AhX̎擾
// 	  	Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa47wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Aisa47GetVersion ̃AhX擾
	pAisa47GetVersion := GetProcAddress(hDLL, 'Aisa47GetVersion');
	if @pAisa47GetVersion = nil then Exit;

	// Aisa47Create ̃AhX擾
	pAisa47Create := GetProcAddress(hDLL, 'Aisa47Create');
	if @pAisa47Create = nil then Exit;

	// Aisa47Close ̃AhX擾
	pAisa47Close := GetProcAddress(hDLL, 'Aisa47Close');
	if @pAisa47Close = nil then Exit;

	// Aisa47GetResource ̃AhX擾
	pAisa47GetResource := GetProcAddress(hDLL, 'Aisa47GetResource');
	if @pAisa47GetResource = nil then Exit;

	// Aisa47InPort ̃AhX擾
	pAisa47InPort := GetProcAddress(hDLL, 'Aisa47InPort');
	if @pAisa47InPort = nil then Exit;

	// Aisa47OutPort ̃AhX擾
	pAisa47OutPort := GetProcAddress(hDLL, 'Aisa47OutPort');
	if @pAisa47OutPort = nil then Exit;

	// Aisa47GetLastError ̃AhX擾
	pAisa47GetLastError := GetProcAddress(hDLL, 'Aisa47GetLastError');
	if @pAisa47GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

