/*****************************************************************************
 *	aisa47w.c
 *
 *	aISA-R47
 *
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 *	Date 1998/05/20
 *
 *****************************************************************************/
#include <windows.h>
#include <tchar.h>
#include "aisa47w.h"	// aISA-R47

//---------- X^eBbN֐ & X^eBbNϐ(萔)	----------------------
static BOOL Aisa47wGetDllExportFunc();
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[pϐ
static FARPROC pAisa47GetVersion;
static FARPROC pAisa47Create;
static FARPROC pAisa47Close;
static FARPROC pAisa47GetResource;
static FARPROC pAisa47InPort;
static FARPROC pAisa47OutPort;
static FARPROC pAisa47GetLastError;

BOOL Aisa47wDllOpen ( void )
/*****************************************************************************
 * @\  aisa47.dll[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL != NULL) {
		return FALSE;
	}
	hDLL = (HMODULE)LoadLibrary(AISA47_DLL_NAME);
	if (hDLL == NULL) {
		return FALSE;
	}
	if (Aisa47wGetDllExportFunc() == FALSE) {
		// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Aisa47wDllClose();
		return FALSE;
	}
	return TRUE;
}

BOOL Aisa47wDllClose ( void )
/*****************************************************************************
 * @\  aisa47.dllA[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	if (FreeLibrary(hDLL) == TRUE) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

BOOL Aisa47wGetVersion ( PDWORD pdwDllVer, PDWORD pdwDrvVer )
/*****************************************************************************
 * @\  aISA-R47DLL,Driver̃o[Wԍ擾
 * 	 pdwDllVer --- DLLo[Wԍi[AhX
 *		 pdwDrvVer --- Drivero[Wԍi[AhX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa47GetVersion)(pdwDllVer, pdwDrvVer);
}

BOOL Aisa47wCreate ( PWORD pwLogSlot )
/*****************************************************************************
 * @\  aISA-R47̔Cӂ̃foCX̎gp錾
 * 	 pwLogSlot	--- gpfoCXi[AhX
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa47Create)(pwLogSlot);
}

BOOL Aisa47wClose ( WORD wLogSlot )
/*****************************************************************************
 * @\  aISA-R47̔Cӂ̃foCX̎gpJ
 * 	 wLogSlot  --- gpfoCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa47Close)(wLogSlot);
}

BOOL Aisa47wGetResource ( WORD wLogSlot, PAISA47R pResInfo )
/*****************************************************************************
 * @\  wfoCX̃\[X擾
 * 	 wLogSlot --- ׂfoCX
 *		 pResInfo --- \[Xi[\̂̃AhX
 * ߒl	 TRUE	  --- 
 *		 FALSE	  --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa47GetResource)(wLogSlot, pResInfo);
}

BOOL Aisa47wInPort ( WORD wLogSlot, DWORD dwPort, PBYTE pbInValue )
/*****************************************************************************
 * @\  Cӂ̃|[gf[^
 * 	 wLogSlot  --- ͂foCX
 *		 dwPort	   --- ͂|[g
 *		 pbInValue --- ̓f[^i[AhX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa47InPort)(wLogSlot, dwPort, pbInValue);
}

BOOL Aisa47wOutPort ( WORD wLogSlot, DWORD dwPort, BYTE bOutValue )
/*****************************************************************************
 * @\  Cӂ̃|[gփf[^o
 * 	 wLogSlot  --- o͂foCX
 *		 dwPort	   --- o͂|[g
 *		 bOutValue --- o̓f[^
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa47OutPort)(wLogSlot, dwPort, bOutValue);
}

DWORD Aisa47wGetLastError ( WORD wLogSlot )
/*****************************************************************************
 * @\  aISA-R47̃G[R[h
 * 	 wLogSlot  --- G[foCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return AISA47_ERR_WRAPDLL;
	}
	return (*pAisa47GetLastError)(wLogSlot);
}

static BOOL Aisa47wGetDllExportFunc ( void )
/*---------------------------------------------------------------------------
 * 	 DLLGNX|[g֐AhX̎擾
 * 	 Ȃ
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *---------------------------------------------------------------------------*/
{
	// Aisa47GetVersion ̃AhX擾
	pAisa47GetVersion = GetProcAddress(hDLL, _T("Aisa47GetVersion"));
	if (pAisa47GetVersion == NULL) {
		return FALSE;
	}

	// Aisa47Create ̃AhX擾
	pAisa47Create = GetProcAddress(hDLL, _T("Aisa47Create"));
	if (pAisa47Create == NULL) {
		return FALSE;
	}

	// Aisa47Close ̃AhX擾
	pAisa47Close = GetProcAddress(hDLL, _T("Aisa47Close"));
	if (pAisa47Close == NULL) {
		return FALSE;
	}

	// Aisa47GetResource ̃AhX擾
	pAisa47GetResource = GetProcAddress(hDLL, _T("Aisa47GetResource"));
	if (pAisa47GetResource == NULL) {
		return FALSE;
	}

	// Aisa47InPort ̃AhX擾
	pAisa47InPort = GetProcAddress(hDLL, _T("Aisa47InPort"));
	if (pAisa47InPort == NULL) {
		return FALSE;
	}

	// Aisa47OutPort ̃AhX擾
	pAisa47OutPort = GetProcAddress(hDLL, _T("Aisa47OutPort"));
	if (pAisa47OutPort == NULL) {
		return FALSE;
	}

	// Aisa47GetLastError ̃AhX擾
	pAisa47GetLastError = GetProcAddress(hDLL, _T("Aisa47GetLastError"));
	if (pAisa47GetLastError == NULL) {
		return FALSE;
	}
	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
